#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Authors : Roberto Majadas <roberto.majadas@openshine.com>
#           Oier Blasco <oierblasco@gmail.com>
#           Alvaro Peña <alvaro.pena@openshine.com>
#
# Copyright (c) 2003-2007, Telefonica Móviles España S.A.U.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import gtk
import gtk.glade
import gobject
import MSD
import os

class MSDAddressbookTab:
    def __init__ (self, pref_obj):
        self.xml = pref_obj.xml
        self.conf = pref_obj.conf

        # Addressbook widgets tab
        self.addressbook_main_image = self.xml.get_widget ("addressbook_main_image")
        self.addressbook_main_image.set_from_file (os.path.join(MSD.icons_files_dir, "addressbook_32x32.png"))
        self.addressbook_copiagenda_link = self.xml.get_widget ("copiagenda_link_button")

    def connect_signals(self):
        self.addressbook_copiagenda_link.connect("clicked", self.__copia_agenda_link_cb, None)

    
    def __copia_agenda_link_cb (self, widget, data):
        os.system("gnome-open %s" % MSD.copiagenda_uri)
            
